UNIT
  LookUpTables;


INTERFACE
USES
  Globals;

TYPE
  Str2 = String[2];

CONST  {-- lookup for Sq to String representation }
  SqToStr : ARRAY[0..63] OF Str2 = ('A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1',
                                    'A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2',
                                    'A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3',
                                    'A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4',
                                    'A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5',
                                    'A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6', 'H6',
                                    'A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7', 'H7',
                                    'A8', 'B8', 'C8', 'D8', 'E8', 'F8', 'G8', 'H8');



CONST
  {-- the tables are used for white and black buy using Sq XOR 56 to flip the table }
  {-- they are intentional symetrical for simplicity and debugging }
  {-- they start at -1 because the piecelists uses -1 to flag no piece }

  {-- for king protection and then advancement }
  Pst_pawn : ARRAY[-1..63] OF Int8 = (0,
    0,  0,   0,  0,    0,   0,  0,  0,
    5, 10,  10, -20, -20,  10, 10,  5,
    5, -5, -10,   0,   0, -10, -5,  5,
    0,  0,   0,  20,  20,   0,  0,  0,
    5,  5,  10,  25,  25,  10,  5,  5,
   10, 10,  20,  30,  30,  20, 10, 10,
   50, 50,  50,  50,  50,  50, 50, 50,
   99, 99,  99,  99,  99,  99, 99, 99);

   {-- encourage knights to the center }
   Pst_knight : ARRAY[-1..63] OF Int16 = (0,
     -50, -40, -30, -30, -30, -30, -40,  -50,
     -40, -20,   0,   5,   5,   0, -20,  -40,
     -30,   5,  10,  15,  15,  10,   5,  -30,
     -30,   0,  15,  20,  20,  15,   0,  -30,
     -30,   5,  15,  20,  20,  15,   5,  -30,
     -30,   0,  10,  15,  15,  10,   0,  -30,
     -40, -20,   0,   5,   5,   0, -20,  -40,
     -50, -40, -30, -30, -30, -30, -40,  -50);


   Pst_bishop : ARRAY[-1..63] OF Int16 = (0,
    -20, -10, -10, -10, -10, -10, -10, -20,
    -10,   5,   0,   0,   0,   0,   5, -10,
    -10,  10,  10,  10,  10,  10,  10, -10,
    -10,   0,  10,  10,  10,  10,   0, -10,
    -10,   5,   5,  10,  10,   5,   5, -10,
    -10,   0,   5,  10,  10,   5,   0, -10,
    -10,   0,   0,   0,   0,   0,   0, -10,
    -20, -10, -10, -10, -10, -10, -10, -20);

   {-- rewards 7th rank occupation }
   Pst_rook : ARRAY[-1..63] OF Int16 = (0,
      0,  0,  0,  0,  0,  0,  0,  0,
     -5,  0,  0,  0,  0,  0,  0,  0,
     -5,  0,  0,  0,  0,  0,  0, -5,
     -5,  0,  0,  0,  0,  0,  0,  0,
     -5,  0,  0,  0,  0,  0,  0, -5,
     -5,  0,  0,  0,  0,  0,  0, -5,
      5, 10, 10, 10, 10, 10, 10,  5,
      0,  0,  0,  0,  0,  0,  0,  0);

   Pst_queen : ARRAY[-1..63] OF Int16 = (0,
    -20, -10, -10, -5, -5, -10, -10, -20,
    -10,   0,   5,  0,  0,   5,   0, -10,
    -10,   5,   5,  5,  5,   5,   5, -10,
      0,   0,   5,  5,  5,   5,   0,   0,
     -5,   0,   5,  5,  5,   5,   0,  -5,
    -10,   0,   5,  5,  5,   5,   0, -10,
    -10,   0,   0,  0,  0,   0,   0, -10,
    -20, -10, -10, -5, -5, -10, -10, -20);

   Pst_king_mg : ARRAY[-1..63] OF Int16 = (0,
     20,  30,  10,  0,    0, 10,   30,  20,
     20,  20,   0,  0,    0,  0,   20,  20,
    -10, -20, -20, -20, -20, -20, -20, -10,
    -20, -30, -30, -40, -40, -30, -30, -20,
    -30, -40, -40, -50, -50, -40, -40, -30,
    -30, -40, -40, -50, -50, -40, -40, -30,
    -30, -40, -40, -50, -50, -40, -40, -30,
    -30, -40, -40, -50, -50, -40, -40, -30);

   Pst_king_eg : ARRAY[-1..63] OF Int16 = (0,
     -15, -10, -10, -10, -10, -10, -10, -15,
     -10, -10,   0,   0,   0,   0, -10, -10,
     -10,  -2,   7,  10,  10,   7,  -2, -10,
     -10,  -2,  10,  15,  15,  10,  -2, -10,
     -10,  -2,  10,  10,  15,  10,  -2, -10,
     -10,  -2,   7,  10,  10,   7,  -2, -10,
     -10, -10,   0,   0,   0,   0, -10, -10,
     -15, -10, -10, -10, -10, -10, -10, -15);


IMPLEMENTATION
{-----------------------------------------------------------------------------------------------------------}


BEGIN
END.
